include:
  - project: "uis/devops/continuous-delivery/ci-templates"
    file: "/auto-devops/auto-devops.gitlab-ci.yml"
    ref: v6.0.0

  - project: "uis/devops/continuous-delivery/ci-templates"
    file: "/auto-devops/artifact-registry.yml"
    ref: v3.7.1
  - project: "uis/devops/continuous-delivery/ci-templates"
    file: "/commitlint.yml"
    ref: v3.7.1
  - project: "uis/devops/continuous-delivery/ci-templates"
    file: "/auto-devops/common-pipeline.yml"
    ref: v3.7.1

variables:
  DAST_DISABLED: "true"

cache:
  paths:
    - node_modules/
    - dist/

install_dependencies:
  image: node:16-alpine
  stage: build
  script:
    - npm ci
    - npm install -g typescript
    - npm run build
  artifacts:
    paths:
      - node_modules/
      - dist/
    expire_in: 1h

run_tests:
  image: node:16-alpine
  stage: test
  script:
    - npm run test
  rules:
    - if: $CI_COMMIT_BRANCH
      when: on_success
  allow_failure: false

check_version:
  image: node:16-alpine
  stage: test
  before_script:
    - apk --no-cache add jq
  script:
    - >
      if npm view $CI_PROJECT_NAME version --registry https://registry.npmjs.org/ | grep -q "$(jq -r .version package.json)"; then
        echo "Version already published.";
        exit 1;
      else
        echo "Version check passed. Proceeding to publish.";
      fi

publish_test:
  stage: test
  image: node:16-alpine
  script:
    - echo "//registry.npmjs.org/:_authToken=$NPM_AUTH_TOKEN" > .npmrc
    - npm publish --dry-run

publish:
  stage: deploy
  image: node:16-alpine
  script:
    - echo "//registry.npmjs.org/:_authToken=$NPM_AUTH_TOKEN" > .npmrc
    - npm publish --access=public
  only:
    - main
